<img src="branding/logo-square.svg"  width="120" height="120">

kOS
===

kOS (read 'chaos') is a simple OS based on CoreOS with the applied modifications for this repositories needs. It'll provide an easy way to reliably update the base OS of the cluster.

Usage
---

To install kOS, it's currently mandatory to install a regular CoreOS machine first. Then run the following command:

```shell
sudo rpm-ostree rebase --experimental ostree-unverified-registry:quay.io/shivering-isles/kos:stable
sudo systemctl reboot
```

This will download the latest images version and rebase the existing system to this customised image.

For updates, just run the regular `rpm-ostree upgrade`.

Concept
---

The base setup is simple: A general CoreOS setup on a host, which is then rebased to this container image using [the new, experimental coreos layering](https://github.com/coreos/enhancements/blob/main/os/coreos-layering.md). This should provide a solid base for the OS, and allows to use the regular container build pipeline to update tools and the OS itself.

OS requirements
---

The OS requirements to run the current setup are:

- [x] modern software versions
- [x] Kubeadm support
- [x] cri-o support
- [x] TPM-based LUKS encryption
- [x] SELinux support
- [x] cockpit integration
- [x] SSH access
- [x] automated updates

Why kOS?
---

kOS provides the needed flexibility without layering new packages into an image, which allows proper image validation in CI while reducing the risk of potential issues due to package dependency conflicts and alike, it also allows proper adjustment of RPM package sources.

Other than upstream Fedora CoreOS, it is opinionated towards Kubernetes as orchestrator and prepares the OS accordingly with `cri-o` as container engine being prepared for specific Kubernetes versions along with `kubeadm` and the `kubelet` that come preinstalled.

What does the k in kOS stand for? Kubernetes?
---

No. 🤷 I'm not sure yet, what it actually stands for, but it sounds nice, doesn't it?